#
# Copyright (C) 2024 eGloo, Incorporated
#

include $(TOPDIR)/rules.mk

PKG_NAME:=@PACKAGE_TARNAME@
PKG_RELEASE:=1
PKG_MAINTAINER:=Darryl Sokoloski <darryl@egloo.ca>
PKG_LICENSE:=UNLICENSED

PKG_BUILD_PARALLEL:=1
PKG_FIXUP:=autoreconf
PKG_INSTALL:=1

PKG_SOURCE_PROTO:=git
PKG_SOURCE_URL:=@GIT_SOURCE_URL@
PKG_SOURCE_DATE:=@ND_RELEASE_QUARTER@
PKG_SOURCE_VERSION:=v@PACKAGE_VERSION@
#PKG_SOURCE_VERSION:=@GIT_LAST_COMMIT_HASH@
PKG_MIRROR_HASH:=whatever

include $(INCLUDE_DIR)/package.mk

define Package/@PACKAGE_TARNAME@
  SECTION:=libs
  CATEGORY:=Libraries
  TITLE:=@PACKAGE_NAME@
  URL:=http://www.netify.ai/
  DEPENDS:=+netifyd @!USE_UCLIBC
  # Explicitly depend on libstdcpp rather than $(CXX_DEPENDS).  At the moment
  # std::unordered_map is only available via libstdcpp which is required for
  # performance reasons.
  DEPENDS+=+libstdcpp
  EXTRA_DEPENDS:=netifyd (=@ND_RELEASE_QUARTER@-v@NETIFY_MINVER@-1)
endef

define Package/@PACKAGE_TARNAME@/description
This is a plugin template project for writing new Netify Agent sink plugins.
endef

define Package/@PACKAGE_TARNAME@/conffiles
/etc/netifyd/@PACKAGE_TARNAME@.json
/etc/netifyd/plugins.d/10-@PACKAGE_TARNAME@.conf
endef

TARGET_CFLAGS+=-ffunction-sections -fdata-sections -Wno-psabi
TARGET_CXXFLAGS+=-ffunction-sections -fdata-sections -Wno-psabi
TARGET_LDFLAGS+=-Wl,--gc-sections

define Build/Configure
	(cd $(PKG_BUILD_DIR); ./autogen.sh)
	$(call Build/Configure/Default,$(CONFIGURE_ARGS))
endef

define Build/InstallDev
	$(INSTALL_DIR) $(1)/usr/lib
	$(CP) $(PKG_INSTALL_DIR)/usr/lib/lib@PACKAGE_TARNAME@.{a,so*} $(1)/usr/lib/
endef

define Package/@PACKAGE_TARNAME@/install
	$(INSTALL_DIR) $(1)/usr/lib
	$(INSTALL_DIR) $(1)/etc/netifyd/plugins.d
	$(CP) $(PKG_INSTALL_DIR)/usr/lib/lib@PACKAGE_TARNAME@.so.* $(1)/usr/lib/
	$(INSTALL_CONF) $(PKG_INSTALL_DIR)/etc/netifyd/@PACKAGE_TARNAME@.json $(1)/etc/netifyd/
	$(INSTALL_CONF) $(PKG_INSTALL_DIR)/etc/netifyd/plugins.d/10-@PACKAGE_TARNAME@.conf $(1)/etc/netifyd/plugins.d/
endef

$(eval $(call BuildPackage,@PACKAGE_TARNAME@))
